namespace WarmlyShip
{
    public partial class FormClass : Form
    {
        private DrawingWarmlyShip _warmlyShip;

        public DrawingWarmlyShip SelectedShip { get; private set; }

        public FormClass()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            Bitmap bmp = new(pictureBox.Width, pictureBox.Height);
            Graphics g = Graphics.FromImage(bmp);
            _warmlyShip.DrawTransport(g);
            pictureBox.Image = bmp;
        }

		private void SetData()
		{
			Random random = new Random();
			_warmlyShip.SetPosition(random.Next(0, 100), random.Next(0, 100), pictureBox.Width, pictureBox.Height);
			toolStripStatusSpeed.Text = $": { _warmlyShip.warmlyShip?.Speed}";
			toolStripStatusWeight.Text = $": {_warmlyShip.warmlyShip?.Weight}";
			toolStripStatusLabelBodyColor.Text = $": {_warmlyShip.warmlyShip?.BodyColor}";
		}

		private void ButtonCreate_Click(object sender, EventArgs e)
        {
			Random rnd = new();
			Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
			ColorDialog dialog = new();
			if (dialog.ShowDialog() == DialogResult.OK)
			{
				color = dialog.Color;
			}
			_warmlyShip = new DrawingWarmlyShip(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
			SetData();
			Draw();

		}

		private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonLeft":
                    _warmlyShip?.MoveTransport(Direction.Left);
                    break;
                case "buttonUp":
					_warmlyShip?.MoveTransport(Direction.Up);
					break;
                case "buttonRight":
					_warmlyShip?.MoveTransport(Direction.Right);
					break;
                case "buttonDown":
					_warmlyShip?.MoveTransport(Direction.Down);
					break;
            }
            Draw();
        }

        private void PictureBox_Resize(object sender, EventArgs e)
        {
			_warmlyShip?.ChangeBorders(pictureBox.Width, pictureBox.Height);
			Draw();
		}

        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
			Random rnd = new();
			Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
			ColorDialog dialog = new();
			if (dialog.ShowDialog() == DialogResult.OK)
			{
				color = dialog.Color;
			}
			Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
			ColorDialog dialogDop = new();
			if (dialogDop.ShowDialog() == DialogResult.OK)
			{
				dopColor = dialogDop.Color;
			}
			_warmlyShip = new DrawningMotorShip(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor, Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
			SetData();
			Draw();
		}

        private void ButtonSelectShip_Click(object sender, EventArgs e)
        {
			SelectedShip = _warmlyShip;
			DialogResult = DialogResult.OK;
		}
    }
}