﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyShip
{
	internal class SetShipGeneric<T>
		where T : class
	{
		private readonly List<T> _places;
		public int Count => _places.Count;

		private readonly int _maxCount;

		public SetShipGeneric(int count)
		{
			_maxCount = count;
			_places = new List<T>();
		}

		public int Insert(T ship)
		{
			return Insert(ship, 0);
		}

		public int Insert(T ship, int position)
		{
			if (position < 0 || position > Count || Count == _maxCount) return -1;
			_places.Insert(position, ship);
			return position;
		}

		public T Remove(int position)
		{
			T DelElement = _places[position];
			_places[position] = null;
			return DelElement;
		}

		public T this[int position]
		{
			get
			{
				if (position < 0 || position > Count) return null;
				return _places[position];
			}
			set
			{
				Insert(value, position);
			}
		}


		public IEnumerable<T> GetShips()
		{
			foreach (var ship in _places)
			{
				if (ship != null)
				{
					yield return ship;
				}
				else
				{
					yield break;
				}
			}
		}

	}
}
